//***************************************************************************
//
// TEXT.CPP
// by Harlen C. Batagelo
//
//***************************************************************************

#include <stdio.h>
#include <stdarg.h>
#include <string.h>

#include <GL/glut.h>

#include "common.h"

/////////////////////////////////////////////////////////////////////////////
// Draw bitmapped text at xy location
/////////////////////////////////////////////////////////////////////////////
void Vis3D::printString (float x, float y, char *text, ...)
{
	char atmp[256];

	va_list marker;
	va_start (marker, text);
	vsprintf (atmp, text, marker);
	va_end (marker);

	glRasterPos2f (x, y);
	for(unsigned int ct = 0; ct < strlen (atmp); ct++)
		glutBitmapCharacter(GLUT_BITMAP_HELVETICA_10, atmp[ct]);
} // Vis3D::printString

void Vis3D::drawCell(int x, int y, int z)
{
	glBegin (GL_QUADS);
		glNormal3f (0.0, 0.0, -1.0);
		glVertex3f ( x   *STEP,  y   *STEP,  z   *STEP);
		glVertex3f ( x   *STEP, (y+1)*STEP,  z   *STEP);
		glVertex3f ((x+1)*STEP, (y+1)*STEP,  z   *STEP);
		glVertex3f ((x+1)*STEP,  y   *STEP,  z   *STEP);

		glNormal3f (0.0, 1.0, 0.0);
		glVertex3f ( x   *STEP, (y+1)*STEP,  z   *STEP);
		glVertex3f ( x   *STEP, (y+1)*STEP, (z+1)*STEP);
		glVertex3f ((x+1)*STEP, (y+1)*STEP, (z+1)*STEP);
		glVertex3f ((x+1)*STEP, (y+1)*STEP,  z   *STEP);

		glNormal3f (-1.0, 0.0, 0.0);
		glVertex3f ( x   *STEP,  y   *STEP, (z+1)*STEP);
		glVertex3f ( x   *STEP, (y+1)*STEP, (z+1)*STEP);
		glVertex3f ( x   *STEP, (y+1)*STEP,  z   *STEP);
		glVertex3f ( x   *STEP,  y   *STEP,  z   *STEP);

		glNormal3f (1.0, 0.0, 0.0);
		glVertex3f ((x+1)*STEP,  y   *STEP,  z   *STEP);
		glVertex3f ((x+1)*STEP, (y+1)*STEP,  z   *STEP);
		glVertex3f ((x+1)*STEP, (y+1)*STEP, (z+1)*STEP);
		glVertex3f ((x+1)*STEP,  y   *STEP, (z+1)*STEP);

		glNormal3f (0.0, -1.0, 0.0);
		glVertex3f ((x+1)*STEP,  y   *STEP,  z   *STEP);
		glVertex3f ((x+1)*STEP,  y   *STEP, (z+1)*STEP);
		glVertex3f ( x   *STEP,  y   *STEP, (z+1)*STEP);
		glVertex3f ( x   *STEP,  y   *STEP,  z   *STEP);

		glNormal3f (0.0, 0.0, 1.0);
		glVertex3f ((x+1)*STEP,  y   *STEP, (z+1)*STEP);
		glVertex3f ((x+1)*STEP, (y+1)*STEP, (z+1)*STEP);
		glVertex3f ( x   *STEP, (y+1)*STEP, (z+1)*STEP);
		glVertex3f ( x   *STEP,  y   *STEP, (z+1)*STEP);
	glEnd ();

} // Vis3D::drawCell